﻿using System;
using System.Windows.Forms;
using XCharge.XpressLink2;

namespace EdgeExpressPCIntegrationSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //------------------------------------------------------------------------------
        //Sample parameters:
        //------------------------------------------------------------------------------

        // Invoke the Pin Pad Device set up screen using XML parameters
        private string PPDEditSetupXML = @"
                                    <XLINKEMVREQUEST>
                                      <TRANSACTIONTYPE>PPDEDITSETUP</TRANSACTIONTYPE>
                                    </XLINKEMVREQUEST>";

        // Invoke a signature prompt using XML parameters
        private string PromptSignatureXML = @"
                                    <XLINKEMVREQUEST>
                                      <TRANSACTIONTYPE>PPDPROMPTSIGNATURE</TRANSACTIONTYPE>
                                      <TITLE>Please Sign</TITLE>
                                      <DISPLAYCAPTUREDSIGNATURE>T</DISPLAYCAPTUREDSIGNATURE>
                                    </XLINKEMVREQUEST>";

        // Invoke a Credit Sale transaction using XML parameters
        private string CreditSaleXML
        {
            get
            {
                return string.Format(@"
                                    <XLINKEMVREQUEST>
                                      <TRANSACTIONTYPE>CREDITSALE</TRANSACTIONTYPE>
                                      <XWEBAUTHKEY>{0}</XWEBAUTHKEY>
                                      <XWEBTERMINALID>{1}</XWEBTERMINALID>
                                      <XWEBID>{2}</XWEBID>
                                      <ALLOWDUPLICATES />
                                      <AMOUNT>2.09</AMOUNT>
                                    </XLINKEMVREQUEST>", txtXWebAuthKey.Text, txtXWebTerminalID.Text, txtXWebID.Text);
            }
        }
        //------------------------------------------------------------------------------
        //------------------------------------------------------------------------------


        // Show the PinPad device setup screen
        private void btnEditSetup_Click(object sender, EventArgs e)
        {
            Execute(PPDEditSetupXML);
        }

        // Prompt for a signature on the device
        private void btnPromptForSignature_Click(object sender, EventArgs e)
        {
            Execute(PromptSignatureXML);
        }

        // Start a credit sale transaction
        private void btnCreditSale_Click(object sender, EventArgs e)
        {
            Execute(CreditSaleXML);
        }

        // Execute the given parameter in XpressLink2
        private void Execute(string parameter)
        {
            // Create a XLEmv object from the reference to XpressLink2
            XLEmv xl = new XLEmv();

            // A response string that will get the response information from XpressLink2
            string response;

            // Execute the sample paramaters.
            xl.Execute(parameter, out response);

            // Display the response
            txtResults.Text = response;
        }
    }
}
